Bug 31734 - Loading many small documents causes crash
Summary: Loading many small documents causes crash
Status: RESOLVED WORKSFORME
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
unspecified
Hardware: Other All
: high major
Assignee: Not Assigned
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2010-11-18 09:44 UTC by Alex Thurgood
Modified: 2011-12-22 05:52 UTC (History)
6 users (show)

See Also:
Crash report or crash signature:


Attachments
Test kit, pls. see comments from Rainer Bielefeld (754.56 KB, application/x-compressed)
2010-11-26 08:31 UTC, Rainer Bielefeld Retired
Details
Another test kit (794.15 KB, application/zip)
2010-11-28 08:53 UTC, Rainer Bielefeld Retired
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Alex Thurgood 2010-11-18 09:44:22 UTC
1) Go through the steps described in Issue 31585, using Query_Book as the table data source to produce 118 writer documents (which incidentally contain no data other than the template information of the basic elements.odt document). Each of these mailmerged documents weighs in at 12kb.

2) Quit / close all open documents.

3) Go to File > Open, and select all 188 documents in the File Picker and click on "Open" or "OK" (depending on OS).

4) LibO will start to load the documents, getting slower, and then crash. On my machine (Mac OSX 10.6.5), the crash happens at around document 95.


Alex
Comment 1 Alex Thurgood 2010-11-18 09:45:38 UTC
Sorry, in step 3, that should have read :

"Select all 118 documents"

Alex
Comment 2 Thorsten Behrens (CIB) 2010-11-18 15:34:02 UTC
Alex, any chance you could attach gdb to the running office (it's included in XCode)? I was not able to reproduce the crash, neither on Mac (10.4 here, though), nor on Linux.
Comment 3 Alex Thurgood 2010-11-18 22:54:28 UTC
@Thorsten,

Hmm, I've never been very good with gdb :-/ but will try and check it out. Will have to read up on its usage documentation first...

FWIW, I can also reproduce the same behaviour on OOo 3.2.1, except that I can load just over 100 documents, instead of 95 as with LibO.


Alex
Comment 4 Rainer Bielefeld Retired 2010-11-26 08:28:40 UTC
[Reproducible] with "LibreOffice 3.3.0Beta3 - WIN XP DE [OOO330m9 (build 3.2.99.3)]" 

Modified OS due to my results and attached test kit.

I created 120 documents all only containing 1 character "X", used OOo file dialog from Start Center, browsed for sample documents, selected all and pressed 'Open' buton. OOo started opening documents, but after app. 50 documents (I found 47 ".~lock" files in the folder LibO crashed.
Comment 5 Rainer Bielefeld Retired 2010-11-26 08:31:26 UTC
Created attachment 40588 [details]
Test kit, pls. see comments from Rainer Bielefeld

Serious, but not a blocker, I doubt that many users will try to open such a lot of documents in time.
Comment 6 Thorsten Behrens (CIB) 2010-11-26 10:05:32 UTC
Hm. Tried here, with trivial self-generated sample docs - stopped at 150, because desktop became unbearably slow - this was Linux x86_64 - will retry on Mac later.
Comment 7 Caolán McNamara 2010-11-27 04:32:45 UTC
Unzipped test suite, opened all documents in one go, twiddled my thumbs for a minute or two, closed them all down. And no crash, performance seemed good too. This however is on x86_64 Linux with an obscene amount of memory
Comment 8 Rainer Bielefeld Retired 2010-11-27 04:43:22 UTC
It seems that my crash was because of other reasons, today I did a second test without crash until 70 documents opened, then I terminated the test; unfortunately I have no obscene amount of memory, old PC, old HDD so that a test takes a lot of Time.

So until other news OS back to MAC
Comment 9 Rainer Bielefeld Retired 2010-11-27 07:40:07 UTC
I installed LibO on a second WIN XP PC, same problem, always crashes after app. 50 documents open. Same with OOo 3.1.1 and DEV300m94 for WIN XP on both PC. There is no unusual virtual swap file load.  
I filed 
<http://www.openoffice.org/issues/show_bug.cgi?id=115808>
May be they will find out something?
Comment 10 Rainer Bielefeld Retired 2010-11-28 08:51:25 UTC
This problem is not limited to WRITER documents, I also see it with drawings, pls. see attached test kit. Opening documents from LibO file Dialog (using LibO dialogs) crashes LibO after app. 50 open documents. Different to the crash from WRITER I see a "Documents will have to be recovered" Message during the crash.
An other difference seems to be that I can recover documents and then view the documents (not 100% reproducible), for WRITER documents my LibO always crashes after the recovery.

@Alex:
Can you reproduce the DRAWING problem?

Because of it's impact to Mail Merge Wizzard (pls. see Bug 31585), where lots of documents might be created and opened, I believe this one is a 3.3 blocker.
Comment 11 Rainer Bielefeld Retired 2010-11-28 08:53:04 UTC
Created attachment 40615 [details]
Another test kit
Comment 12 Petr Mladek 2010-11-29 03:37:17 UTC
I am not able to reproduce the crash.

Rainer or others, do you see the same problem with OOo? With the older stable versions or with the last 3.3rc?

It might need quite some effort to optimize LO to work better with many opened documents. I guess that it crashes because of not enough memory. I am afraid that there are many locations where the memory is allocated and where we would need to improve the error handling.

So, if it is an old bug, I would not consider it as a blocker. It would delay the release too much.
Comment 13 Rainer Bielefeld Retired 2010-11-29 10:16:51 UTC
(In reply to comment #12)

> Rainer or others, do you see the same problem with OOo? 

@Petr: Pls see my Comment 9
Comment 14 Thorsten Behrens (CIB) 2010-11-30 02:44:41 UTC
I think this problem may be related to OOo bug http://qa.openoffice.org/issues/show_bug.cgi?id=112766 - any chance the people seeing this crash / problem could try with a *fresh, extension-free install*?
Comment 15 Rainer Bielefeld Retired 2010-11-30 04:37:11 UTC
(In reply to comment #12)
> So, if it is an old bug, I would not consider it as a blocker. It would delay
> the release too much.

I think so, too. It's annoying, very important, and it would really be fine if it could be fixed, but due to our blocker definition (which follows common sense) it's not a blocker.

@tbehrens:
I can try to uninstall all OOo/Libo versions on my laptop, delete all user profiles and reinstall WIN LibO only English LibO. Is that what you need? and if yes, how can we get best profit from that action?
Comment 16 Thorsten Behrens (CIB) 2010-11-30 05:20:25 UTC
@Rainer: no need to purge everything - just a default LibO install with clean user config should suffice. When reading the comments on http://qa.openoffice.org/issues/show_bug.cgi?id=112766 I see some evidence of this being an out-of-memory condition of some sorts.
Comment 17 Alex Thurgood 2010-11-30 09:23:27 UTC
@Thorsten : I take it one can actually remove all of the installed extensions, even the bundled ones ? ;-)

I could reproduce it with Rainer's test kit. I am trying to do a screencam of the Mac OS activity monitor which shows memory usage increasing with each document opened.

Alex
Comment 18 Alex Thurgood 2010-11-30 09:26:13 UTC
Oh and yes, I can also confirm the same behaviour on NeoOffice, and OOo 3.2.1.

Alex
Comment 19 Rainer Bielefeld Retired 2010-12-01 23:10:20 UTC
As announced I tried with "LibreOffice 3.3.0Beta3 - WIN XP DE [OOO330m12 (build 3.2.99.3)]" without any self installed extensions, problem also exists there.

Laptop
Processor: Mobile AMD Sempron 3200+
Hauptspeicher: 1GB
Graphic Card: ATI Radeon Xpress 1100
Monitor : 1200x800
OS: WIN XP SP3
Comment 20 Rainer Bielefeld Retired 2011-01-13 21:36:43 UTC
Tried again with "LibreOffice 3.3.0 RC2 - WIN7  Home Premium (64bit) German UI  [OOO330m18 (build 3.3.0.2)]" on a PC with 4GB and AMD Phenom II X4: no crash,
Comment 21 Thorsten Behrens (CIB) 2011-01-26 03:06:26 UTC
Alex, could you try as well please, preferrably with 3.3 final? thanks.
Comment 22 Alex Thurgood 2011-01-26 03:24:44 UTC
Hi Thorsten,

Tried both testkits with a fresh 3.3 final on Mac OSX.

Another testkit : no crash, all documents opened.

Test kit : all documents opened, albeit much slower than with the Draw documents. Writer documents seem to be much more memory intensive. I thought at one stage that it was going to hang and crash because there was a period of inactivity.

No crash. However, massive screen repainting issues, I was left with a blank screen and the LibO main menus at the top of the screen. Before testing, I already had one Writer document open, and the focus of the app was clearly on this document. When I closed this Writer document, the focus and screen repainting kicked in for the test kit documents.


So although not brilliant from a user perspective, at least it doesn't crash any more :-))

HTH,

Alex
Comment 23 Zack 2011-03-31 09:26:25 UTC
Curious about this bug, I tried both test kits.  I had no problem opening either of them separately (closing the previous one before testing the next one).

I then tried opening the first test kit, and after it had finished loading I tried opening the second one.  This caused a crash of my system with approximately 700 processes of soffice.bin left open.  I was forced to restart.

System:

Windows 7 SP1 x64
Core i5 CPU
4GB DDR3 Memory
Comment 24 Rainer Bielefeld Retired 2011-10-09 09:06:05 UTC
"LibreOffice 3.4.3  - WIN7 Home Premium (64bit) German UI [OOO340m1 (Build:302)]" opens 120 smaöö .odg documents from OOo file dialog without problems.

Anyone here who still has a problem?
Comment 25 Rainer Bielefeld Retired 2011-10-18 21:12:08 UTC
Seems we have got rid of that problem
Comment 26 Björn Michaelsen 2011-12-22 05:35:59 UTC
Remove infoprovider from closed and resolved bugs.
Comment 27 Björn Michaelsen 2011-12-22 05:52:28 UTC
RESOLVED, FIXED or CLOSED bugs cant be KEYWORD NEEDINFO.